import numpy as np

from cs598apk import utils


class ParametricGeometry:
    def __init__(self, fn, dfn):
        self.fn = fn
        self.dfn = dfn

    def points(self, t):
        return self.fn(t)

    def gradient(self, t):
        return self.dfn(t)

    def normals(self, t):
        tx, ty = self.dfn(t)
        return utils.normalize(np.array[ty, -tx])


class FourierGeometry:
    def __init__(self):
        # Intended to support the Fourier series representation from [1]
        #
        # [1] M Rachh et atll, Fast Algorithms for Quadrature by Expansion,
        # JCP, 2017.
        pass
