import numpy as np
import numpy.linalg as nl
import scipy.special as ss
import scipy.linalg.interpolative as sli


def normalize(x, p=2, axis=0):
    return x / nl.norm(x, p, axis=axis)


def bits(x, n):
    b = np.empty(n, dtype=int)
    for i in range(n):
        b[i] = (x & (2 ** i)) >> i

    return b


def factorial(n):
    return np.product(ss.factorial(n))


def cumsum(x):
    return np.hstack([[0], np.cumsum([len(i) for i in x])])


def interp_decomp(A, rank=None, eps=None):
    if rank is None:
        k, idx, proj = sli.interp_decomp(A, eps)
    else:
        idx, proj = sli.interp_decomp(A, rank)
        k = rank

    return k, idx, proj
